#<profile4xi profile = "11" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "zap0001one4xi.py">
#<abstract4xi abstract = "zaps to direction one"/>
#<verify4xi verification = "11" target = "zap2actor4xi.py"/>
#<refer4xi reference = "zap2actor4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'zap0001one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
ack2dragontrace = False 

#" 
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "zap0001one4xi" usage = "target function for zap0000one4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def zap0001one4xi(queue2one, consumer_channel2one, publisher_channel2one, kb2one):  
    '''
    returns skeleton to direction one via queue
    ''' 

    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                      
    # -------------------------------------------------------------------------------------------------                                                               
      
    time2start = time4xi()  
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF ZAP0001ONE4XI - STARTED TIME: ", time2start)                                     # 05:43:30 12/06/10 Pacific Standard Time
        print("\n (STEP 1A2/33) OF ZAP0001ONE4XI -  QUEUE2ONE: ", queue2one)                                        # <queue4xi.Queue4Xi object at 0x054054B0>   
        print("\n (STEP 1A3/33) OF ZAP0001ONE4XI -  CONSUME_CHANNEL4ONE: ", consumer_channel2one)                   # <read-write PipeConnection, handle 224>
        print("\n (STEP 1A4/33) OF ZAP0001ONE4XI -  PUBLISHER_CHANNEL4ONE: ", publisher_channel2one)                # <read-write PipeConnection, handle 220>     
        # print("\n (STEP 1A5/33) OF ZAP0001ONE4XI -  KB2ONE: ", kb2one)                                              # {'1x1y1z': {'2xi': {1: 1, 2: 2, 3: {1: 6.283185307179586, 2: '#848484', 3: 1, 4: 6.283185307179586}, 4: 'dragon1x1y1z', 5: '#6F4A20', 6: 1, 7: 33, 8: 1.7325080757, 9: 0.267949192431, 10: 8, 11: '{started; sense-of-1Skeleton4Xi-started: 06:17:52 12/06/10 Pacific Standard Time}', 12: 'sense', 13: 2}, '8xi': {}, '4xi': {}}, '0x0y39z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y39z', 5: '#9BA2A2', 6: 69, 7: 1, 8: Decimal('39.0'), 9: Decimal('29'), 10: 1, 11: '{passed; object-passed-to-reason-object4xi: zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1}, '8xi': {}, '4xi': {}}, '0x0y59z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y59z', 5: '#9BA2A2', 6: 70, 7: 1, 8: Decimal('59.0'), 9: Decimal('49'), 10: 1, 11: "{returning; kb4xi-returning-by-reason-object4xi: {'object-reason-object4xi': zskeleton4xi.ZSkeleton4Xi object at 0x02A63DD0}; time: 18:58:34 11/11/10 Pacific Standard Time}", 12: 'reason_object4xi', 13: 1}, '8xi': {}, '4xi': {}}, '0x0y19z': {'2xi': {1: 1, 2: 10, 3: {1: 157.07963267948966, 2: '#848484', 3: 3, 4: 52.35987755982989}, 4: 'dragon0x0y19z', 5: '#9BA2A2', 6: 68, 7: 1, 8: Decimal('19.0'), 9: Decimal('9'), 10: 1, 11: '{started; reason-object4xi-started: function reason_object4xi at 0x02A5F660; time: 18:58:34 11/11/10 Pacific Standard Time}', 12: 'reason_object4xi', 13: 1}, '8xi': {}, '4xi': {}}, '0x0y3199z': {'2xi': {1: 1, 2: 3200, 3: {1: 16084954.386379741, 2: '#848484', 3: 4, 4: 4021238.5965949353}, 4: 'dragon0x0y3199z', 5: '#7C6142', 6: 3201, 7: 1, 8: 3200, 9: 0, 10: 1, 11: '{started; sense-of-Cluster4Xi-started: 06:17:53 12/06/10 Pacific Standard Time}', 12: 'cluster', 13: 1}, '8xi': {}, '4xi': {}}, '0x0y3299z': {'2xi': {1: 1, 2: 3300, 3: {1: 17105971.998796422, 2: '#848484', 3: 4, 4: 4276492.9996991055}, 4: 'dragon0x0y3299z', 5: '#9BA2A2', 6: 3302, 7: 1, 8: 3300, 9: 0, 10: 1, 11: '{started; sense-of-Cluster4Xi-started: 06:17:53 12/06/10 Pacific Standard Time}', 12: 'cluster', 13: 1}, '8xi': {}, '4xi': {}}}
 
    
        
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    if ack2debug is True:
        print("\n (STEP 2A/33) OF ZAP0001ONE4XI - TRYING TO PUT TO QUEUE2ONE: ", queue2one)                        # <queue4xi.Queue4Xi object at 0x054054B0>
    
    ack2put = False                                                                                                                           
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SKELETON NODE FOR DIRECTION ONE TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        key2kb = '1x1y1z'
        kb2put = {}
        kb2put[key2kb] = kb2one[key2kb] 
        queue2one.put(kb2put)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF ZAP0001ONE4XI - SUCCEEDED TO PUT TO QUEUE: ", queue2one, " KB2PUT: ", kb2put) 
                                                                                                                    # {'1x1y1z': {'2xi': {1: 1, 2: 2, 3: {1: 6.283185307179586, 2: '#848484', 3: 1, 4: 6.283185307179586}, 4: 'dragon1x1y1z', 5: '#6F4A20', 6: 1, 7: 33, 8: 1.7325080757, 9: 0.267949192431, 10: 8, 11: '{started; sense-of-1Skeleton4Xi-started: 11:25:22 12/07/10 Pacific Standard Time}', 12: 'sense', 13: 2}, '8xi': {}, '4xi': {}}}

        ack2put = True    
    except:
        print("\n (STEP 2D/33) OF ZAP0001ONE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2ONE: ", queue2one) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF ZAP0001ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL4ONE: ", publisher_channel2one)
                                                                                                                    # <read-write PipeConnection, handle 220>
    if ack2put is True:
        message2send4one = "<ack2put4xi>layer02one</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>layer02one</nack2put4xi>" 
                     
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:     
            print(" (STEP 3B/33) OF ZAP0001ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
                                                                                                                    # <ack2put4xi>layer02one</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 220> 
    except:
        print(" (STEP 3C/33) OF ZAP0001ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF ZAP0001ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
                                                                                                                    # <queue4xi.Queue4Xi object at 0x054E7470> 
          
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_zap2actor4xi.txt
#   scope-sense*4xi.xml
#   sense-test-zap2actor4xi.xml
#   reason-test-zap2actor4xi.xml
#   ace-test-zap2actor4xi4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zap0001one4xi.py                          
# ------------------------------------------------------------------------------------------------- 
#"
#/>
